﻿@using LAP.DomainModels.Entities.Client
@model InsuranceDocument
@{
    var extension = Model.Extension;
    var filename = Model.FileName.Replace("'", "/");
    var type = extension.Contains("doc") ? "word" : extension.Contains("xls") ? "excel" : extension.Contains("csv") ? "csv" : extension.Contains("ppt") ? "powerpoint" : extension.Contains("pdf") ? "pdf" : Model.ContentType.Contains("image") ? "image" : Model.ContentType.Contains("audio") ? "audio" : Model.ContentType.Contains("video") ? "video" : Model.ContentType.Contains("text") ? "alt" : Model.ContentType.Contains("link") ? "globe" : "";
    var color = extension.Contains("doc") ? "295497" : extension.Contains("xls") || extension.Contains("csv") ? "1f7244" : extension.Contains("ppt") ? "d14424" : extension.Contains("pdf") ? "cb0606" : Model.ContentType.Contains("image") ? "26b99a" : Model.ContentType.Contains("audio") ? "8950FC" : Model.ContentType.Contains("video") ? "F64E60" : Model.ContentType.Contains("text") ? "3699FF" : Model.ContentType.Contains("link") ? "0073e9" : "008080";
    var fun = Model.FileSize > 0 ? $"clientFileDownload('documents/insurance', '{filename}', '{Model.VersionId}',{Model.Id},true)" : $"openFileOrLinkNewWindow('{filename}')";
    var statusClass = string.Empty;
    var statusIcon = string.Empty;
}
<div class="modal-dialog max-w-550px modal-dialog-scrollable" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Insurance Document Review</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close" id="btn-close">
                <i aria-hidden="true" class="ki ki-close"></i>
            </button>
        </div>
        <form action="admin/adviser/insurancedocumentreview" class="form fv-plugins-bootstrap fv-plugins-framework" id="insurance-document-review-frm" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="onFormCompleteDataTable">
            <input asp-for="Guid" />
            <div class="modal-body scrollable-modal-body">
                <div class="form-group">
                    <label asp-for="FileName">File Name/Url</label>
                    <div class="input-group">
                        <input class="form-control" asp-for="FileName" disabled />
                        <div class="input-group-append" role="button" onclick="@fun">
                            <span class="input-group-text" style="background:#ffffff">
                                @if (Model.Extension.Contains("eps"))
                                {
                                    <span class='eps-icon-container position-relative' style="top:5px" id="icon-@Model.Id" data-toggle="tooltip" data-original-title="Click here to @(Model.FileSize > 0 ? "download" : "view")" data-offset="0 20px">
                                        <span class='icon-text' style="font-size:9px;top:0;left:2px">EPS</span>
                                        <i class='fa fa-2x fa-file' style='color:#008080'></i>
                                    </span>
                                    <i class="fas fa-arrow-down animated faa-falling ml-2 text-primary d-none" id="loader-@Model.Id" style="line-height:normal"></i>
                                }
                                else
                                {
                                    <i class="fas fa@(Model.FileSize > 0 ? "-file" : "")@(type.Length > 0 ? "-" : "")@type @(Model.FileSize > 0 ? "fa-2x" : "")" style="color:#@color" id="icon-@Model.Id" data-toggle="tooltip" data-original-title="Click here to @(Model.FileSize > 0 ? "download" : "view")" data-offset="0 20px"></i>
                                    <i class="fas fa-arrow-down animated faa-falling ml-2 text-primary d-none" id="loader-@Model.Id" style="line-height:normal"></i>
                                }
                            </span>
                        </div>
                    </div>
                </div>
                @if (Model.FileSize > 0)
                {
                    <div class="form-group row">
                        <div class="col-1">
                            <span class="switch switch-icon mt-2 switch-sm switch-custom">
                                <label>
                                    <input type="checkbox" asp-for="ReqiuredChange">
                                    <span></span>
                                </label>
                            </span>
                        </div>
                        <label class="col-8 col-form-label ml-1" asp-for="ReqiuredChange">
                            Changes required in above document?
                        </label>
                    </div>
                }
                <div class="form-group">
                    <label asp-for="Status"></label>
                    <div class="radio-inline" id="status-wrapper">
                        @foreach (var item in Html.GetEnumSelectList<InsuranceDocumentStatusEnum>().Where(m => m.Value != ((int)InsuranceDocumentStatusEnum.Pending).ToString()))
                        {
                            statusClass = item.Value == ((int)InsuranceDocumentStatusEnum.Approved).ToString() ? "success" : item.Value == ((int)InsuranceDocumentStatusEnum.Issued).ToString() ? "info" : item.Value == ((int)InsuranceDocumentStatusEnum.Rejected).ToString() ? "danger" : "";
                            statusIcon = item.Value == ((int)InsuranceDocumentStatusEnum.Approved).ToString() ? "fa fa-check" : item.Value == ((int)InsuranceDocumentStatusEnum.Issued).ToString() ? "far fa-thumbs-up" : item.Value == ((int)InsuranceDocumentStatusEnum.Rejected).ToString() ? "fa fa-times" : "";
                            <input type="radio" asp-for="Status" class="stv-radio-button" value="@item.Value" id="@item.Text"
                               checked="@((item.Value == ((int)Model.Status).ToString()) ? "checked" : null)" />
                            <label for="@item.Text" class="btn btn-text-@statusClass btn-hover-light-@statusClass"><i class="@statusIcon text-@statusClass"></i>@item.Text</label>
                        }
                    </div>
                    <span asp-validation-for="Status" class="text-danger"></span>
                </div>
                <div class="form-group">
                    <label asp-for="AdviserNote"></label>
                    <textarea class="form-control" asp-for="AdviserNote" disabled></textarea>
                </div>
                <div class="form-group">
                    <label asp-for="ReviewerNote"></label>
                    <textarea class="form-control" asp-for="ReviewerNote"></textarea>
                    <span asp-validation-for="ReviewerNote" class="text-danger"></span>
                </div>
            </div>
            <div class="modal-footer">
                <button class="btn btn-primary font-weight-bold" id="btn-review">
                    <i class="la la-save"></i>Save
                </button>
            </div>
        </form>
    </div>
</div>
<script>
    var status = $("input[name='Status']:checked").val();
    if(status != InsuranceDocumentStatus.Approved.Value)
        $("#Issued").prop("disabled",true);
    var frm = $("#insurance-document-review-frm");
    frm.validate({
        rules: {
            Status :{
                required: true
            },
            ReviewerNote: {
                required: function () {
                    var isRequired = false;
                    var status = $('input[name="Status"]:checked').val();
                    var requireChange = $("#ReqiuredChange").is(":checked");
                    if ((status == InsuranceDocumentStatus.Approved.Value && requireChange) || status == InsuranceDocumentStatus.Rejected.Value)
                        isRequired = true;
                    return isRequired;
                }
            }
        },
        messages: {
            Status:"Provide Status",
            ReviewerNote: "Provide Reviewer Note",
        },
        errorPlacement: function (error, element) {
            if (element.is(":radio"))
                error.appendTo(element.closest(".form-group"));
            else
                error.insertAfter(element);
        }
    });
    $("#ReqiuredChange").change(function () {
        frm.resetValidation();
    });
    clearDropzone();
    var dropzoneOptions = dropzoneDefaultOptions;
    dropzoneOptions.url = "adviser/home/insurancedocumentupload";
    dropzoneOptions.maxFilesize = 100; // MB
    dropzoneOptions.sending = function (file, xhr, formData) {
        var frm = $("#insurance-document-upload-form");
        formData.append("id", frm.find("#Id").val());
        formData.append("guid", frm.find("#Guid").val());
        formData.append("reviewerNote", frm.find("#ReviewerNote").val());
        initToastProgress();
    };
    dropzoneOptions.success = function (file, response) {
        if (file.accepted) {
            var swalOptions = successSwalOptions;
            swalOptions.title = response.message;
            Swal.fire(swalOptions);
            if (window["datatable"] != undefined)
                datatable.reload();
        }
        else {
            toastr.options = toastrOptions;
            toastr.error(response.message);
        }
    };
    $('#insurance-document-upload').dropzone(dropzoneOptions);

    $(document).on("click", "#InsuranceDocumentUploadModal #btn_submit_upload", function (e) {
        e.preventDefault();
        enableDisableUpload(true);
        Dropzone.forElement(".dropzone").processQueue();
    });
</script>
